#include <bits/stdc++.h>
using namespace std;

long long niz[1000006];
long long zbir=0;
void izracunaj(long long a, long long b, long long k)
{
    if(k==0){
        zbir=(zbir+niz[b]-niz[a-1])%1000000007;
    }
    else{
        for(int i=a;i<=b;i++)
        {
            for(int j=i;j<=b;j++)
            {
                izracunaj(i,j,k-1);
            }
        }
    }
}

int main(){

    long long n,k;
    cin>>n>>k;
    niz[0]=0;
    for(long long i=1;i<=n;i++)
    {
        cin>>niz[i];
        niz[i]+=niz[i-1];
    }
    izracunaj(1,n,k);
    cout<<zbir;

}